# class Symbol

`Symbol` objects represent names and some strings inside the Ruby interpreter. They are generated using the `:name` and `:"string"` literals syntax, and by the various `to_sym` methods. The same `Symbol` object will be created for a given name or string for the duration of a program's execution, regardless of the context or meaning of that name. Thus if `Fred` is a constant in one context, a method in another, and a class in a third, the `Symbol` `:Fred` will be the same object in all three contexts.

    module One
      class Fred
      end
      $f1 = :Fred
    end
    module Two
      Fred = 1
      $f2 = :Fred
    end
    def Fred()
    end
    $f3 = :Fred
    $f1.object_id   #=> 2514190
    $f2.object_id   #=> 2514190
    $f3.object_id   #=> 2514190

### Public Class Methods

all_symbols → array click to toggle source

Returns an array of all the symbols currently in Ruby's symbol table.

    Symbol.all_symbols.size    #=> 903
    Symbol.all_symbols[1,20]   #=> [:floor, :ARGV, :Binding, :symlink,
                                    :chown, :EOFError, :$;, :String,
                                    :LOCK_SH, :"setuid?", :$<,
                                    :default_proc, :compact, :extend,
                                    :Tms, :getwd, :$=, :ThreadGroup,
                                    :wait2, :$>]

    VALUE
    rb_sym_all_symbols(void)
    {
        VALUE ary = rb_ary_new2(global_symbols.str_sym->num_entries);
        st_foreach(global_symbols.str_sym, symbols_i, ary);
        return ary;
    }

json_create(o) click to toggle source

Deserializes `JSON` string by converting the `string` value stored in the object to a `Symbol`

    # File ext/json/lib/json/add/symbol.rb, line 22
    def self.json_create(o)
      o['s'].to_sym
    end

### Public Instance Methods

symbol <=> other_symbol → -1, 0, +1, or nil click to toggle source

Compares `symbol` with `other_symbol` after calling `to_s` on each of the symbols. Returns -1, 0, +1, or `nil` depending on whether `symbol` is less than, equal to, or greater than `other_symbol`.

`nil` is returned if the two values are incomparable.

See String#<=> for more information.

    static VALUE
    sym_cmp(VALUE sym, VALUE other)
    {
        if (!SYMBOL_P(other)) {
            return Qnil;
        }
        return rb_str_cmp_m(rb_sym2str(sym), rb_sym2str(other));
    }

sym == obj → true or false click to toggle source

Equality—If sym and obj are exactly the same symbol, returns `true`.

    #define sym_equal rb_obj_equal

sym == obj → true or false click to toggle source

Equality—If sym and obj are exactly the same symbol, returns `true`.

    #define sym_equal rb_obj_equal

sym =~ obj → integer or nil click to toggle source

Returns `sym.to_s =~ obj`.

    static VALUE
    sym_match(VALUE sym, VALUE other)
    {
        return rb_str_match(rb_sym2str(sym), other);
    }

sym[idx] → char click to toggle source
sym[b, n] → string

Returns `sym.to_s[]`.

    static VALUE
    sym_aref(int argc, VALUE *argv, VALUE sym)
    {
        return rb_str_aref_m(argc, argv, rb_sym2str(sym));
    }

as_json(*) click to toggle source

Returns a hash, that will be turned into a `JSON` object and represent this object.

    # File ext/json/lib/json/add/symbol.rb, line 9
    def as_json(*)
      {
        JSON.create_id => self.class.name,
        's'            => to_s,
      }
    end

capitalize → symbol click to toggle source
capitalize([options]) → symbol

Same as `sym.to_s.capitalize.intern`.

    static VALUE
    sym_capitalize(int argc, VALUE *argv, VALUE sym)
    {
        return rb_str_intern(rb_str_capitalize(argc, argv, rb_sym2str(sym)));
    }

casecmp(other_symbol) → -1, 0, +1, or nil click to toggle source

Case-insensitive version of `Symbol#<=>`. Currently, case-insensitivity only works on characters A-Z/a-z, not all of Unicode. This is different from `Symbol#casecmp?`.

    :aBcDeF.casecmp(:abcde)     #=> 1
    :aBcDeF.casecmp(:abcdef)    #=> 0
    :aBcDeF.casecmp(:abcdefg)   #=> -1
    :abcdef.casecmp(:ABCDEF)    #=> 0

`nil` is returned if the two symbols have incompatible encodings, or if `other_symbol` is not a symbol.

    :foo.casecmp(2)   #=> nil
    "\u{e4 f6 fc}".encode("ISO-8859-1").to_sym.casecmp(:"\u{c4 d6 dc}")   #=> nil

    static VALUE
    sym_casecmp(VALUE sym, VALUE other)
    {
        if (!SYMBOL_P(other)) {
            return Qnil;
        }
        return str_casecmp(rb_sym2str(sym), rb_sym2str(other));
    }

casecmp?(other_symbol) → true, false, or nil click to toggle source

Returns `true` if `sym` and `other_symbol` are equal after Unicode case folding, `false` if they are not equal.

    :aBcDeF.casecmp?(:abcde)     #=> false
    :aBcDeF.casecmp?(:abcdef)    #=> true
    :aBcDeF.casecmp?(:abcdefg)   #=> false
    :abcdef.casecmp?(:ABCDEF)    #=> true
    :"\u{e4 f6 fc}".casecmp?(:"\u{c4 d6 dc}")   #=> true

`nil` is returned if the two symbols have incompatible encodings, or if `other_symbol` is not a symbol.

    :foo.casecmp?(2)   #=> nil
    "\u{e4 f6 fc}".encode("ISO-8859-1").to_sym.casecmp?(:"\u{c4 d6 dc}")   #=> nil

    static VALUE
    sym_casecmp_p(VALUE sym, VALUE other)
    {
        if (!SYMBOL_P(other)) {
            return Qnil;
        }
        return str_casecmp_p(rb_sym2str(sym), rb_sym2str(other));
    }

dclone() click to toggle source

provides a unified `clone` operation, for `REXML::XPathParser` to use across multiple `Object` types

    # File lib/rexml/xpath_parser.rb, line 18
    def dclone ; self ; end

downcase → symbol click to toggle source
downcase([options]) → symbol

Same as `sym.to_s.downcase.intern`.

    static VALUE
    sym_downcase(int argc, VALUE *argv, VALUE sym)
    {
        return rb_str_intern(rb_str_downcase(argc, argv, rb_sym2str(sym)));
    }

empty? → true or false click to toggle source

Returns whether sym is :“” or not.

    static VALUE
    sym_empty(VALUE sym)
    {
        return rb_str_empty(rb_sym2str(sym));
    }

encoding → encoding click to toggle source

Returns the `Encoding` object that represents the encoding of sym.

    static VALUE
    sym_encoding(VALUE sym)
    {
        return rb_obj_encoding(rb_sym2str(sym));
    }

id2name → string click to toggle source

Returns the name or string corresponding to sym.

    :fred.id2name   #=> "fred"
    :ginger.to_s    #=> "ginger"

    VALUE
    rb_sym_to_s(VALUE sym)
    {
        return str_new_shared(rb_cString, rb_sym2str(sym));
    }

inspect → string click to toggle source

Returns the representation of sym as a symbol literal.

    :fred.inspect   #=> ":fred"

    static VALUE
    sym_inspect(VALUE sym)
    {
        VALUE str = rb_sym2str(sym);
        const char *ptr;
        long len;
        char *dest;

        if (!rb_str_symname_p(str)) {
            str = rb_str_inspect(str);
            len = RSTRING_LEN(str);
            rb_str_resize(str, len + 1);
            dest = RSTRING_PTR(str);
            memmove(dest + 1, dest, len);
        }
        else {
            rb_encoding *enc = STR_ENC_GET(str);
            RSTRING_GETMEM(str, ptr, len);
            str = rb_enc_str_new(0, len + 1, enc);
            dest = RSTRING_PTR(str);
            memcpy(dest + 1, ptr, len);
        }
        dest[0] = ':';
        return str;
    }

intern → sym click to toggle source

In general, `to_sym` returns the `Symbol` corresponding to an object. As sym is already a symbol, `self` is returned in this case.

    static VALUE
    sym_to_sym(VALUE sym)
    {
        return sym;
    }

length → integer click to toggle source

Same as `sym.to_s.length`.

    static VALUE
    sym_length(VALUE sym)
    {
        return rb_str_length(rb_sym2str(sym));
    }

match(pattern) → matchdata or nil click to toggle source
match(pattern, pos) → matchdata or nil

Returns `sym.to_s.match`.

    static VALUE
    sym_match_m(int argc, VALUE *argv, VALUE sym)
    {
        return rb_str_match_m(argc, argv, rb_sym2str(sym));
    }

match?(pattern) → true or false click to toggle source
match?(pattern, pos) → true or false

Returns `sym.to_s.match?`.

    static VALUE
    sym_match_m_p(int argc, VALUE *argv, VALUE sym)
    {
        return rb_str_match_m_p(argc, argv, sym);
    }

succ click to toggle source

Same as `sym.to_s.succ.intern`.

    static VALUE
    sym_succ(VALUE sym)
    {
        return rb_str_intern(rb_str_succ(rb_sym2str(sym)));
    }

size → integer click to toggle source

Same as `sym.to_s.length`.

    static VALUE
    sym_length(VALUE sym)
    {
        return rb_str_length(rb_sym2str(sym));
    }

slice(idx) → char click to toggle source
slice(b, n) → string

Returns `sym.to_s[]`.

    static VALUE
    sym_aref(int argc, VALUE *argv, VALUE sym)
    {
        return rb_str_aref_m(argc, argv, rb_sym2str(sym));
    }

succ click to toggle source

Same as `sym.to_s.succ.intern`.

    static VALUE
    sym_succ(VALUE sym)
    {
        return rb_str_intern(rb_str_succ(rb_sym2str(sym)));
    }

swapcase → symbol click to toggle source
swapcase([options]) → symbol

Same as `sym.to_s.swapcase.intern`.

    static VALUE
    sym_swapcase(int argc, VALUE *argv, VALUE sym)
    {
        return rb_str_intern(rb_str_swapcase(argc, argv, rb_sym2str(sym)));
    }

to_json(*a) click to toggle source

Stores class name (Symbol) with `String` representation of `Symbol` as a `JSON` string.

    # File ext/json/lib/json/add/symbol.rb, line 17
    def to_json(*a)
      as_json.to_json(*a)
    end

to_proc click to toggle source

Returns a Proc object which responds to the given method by sym.

    (1..3).collect(&:to_s)  #=> ["1", "2", "3"]

    VALUE
    rb_sym_to_proc(VALUE sym)
    {
    }

to_s → string click to toggle source

Returns the name or string corresponding to sym.

    :fred.id2name   #=> "fred"
    :ginger.to_s    #=> "ginger"

    VALUE
    rb_sym_to_s(VALUE sym)
    {
        return str_new_shared(rb_cString, rb_sym2str(sym));
    }

to_sym → sym click to toggle source

In general, `to_sym` returns the `Symbol` corresponding to an object. As sym is already a symbol, `self` is returned in this case.

    static VALUE
    sym_to_sym(VALUE sym)
    {
        return sym;
    }

upcase → symbol click to toggle source
upcase([options]) → symbol

Same as `sym.to_s.upcase.intern`.

    static VALUE
    sym_upcase(int argc, VALUE *argv, VALUE sym)
    {
        return rb_str_intern(rb_str_upcase(argc, argv, rb_sym2str(sym)));
    }